#ifndef FILTER_STRINGS_H
#define FILTER_STRINGS_H
#include <sqlextract/filter/filter_core.h>
#include <sqlextract/error.h>

#define FILTER_STRINGS_NONE             0
#define FILTER_STRINGS_INVERSE          (1<<0)
#define FILTER_STRINGS_CASE_INSENSITIVE (1<<1)

struct filter_t *filter_create_like(logfilter_error *error, struct filter_t *lhs,
		struct filter_t *pattern, struct filter_t *escape);

struct filter_t *filter_create_regexp(logfilter_error *error, struct filter_t *lhs,
		struct filter_t *pattern, int flags);

struct filter_t *filter_create_concat(struct filter_t *lhs,
		struct filter_t *rhs);

#endif
