#include <stdio.h>
#include <stdlib.h>

#include "options.h"

#include <sqlextract/strid.h>
#include <sqlextract/command.h>
#include <sqlextract/sqlextract.h>

#include <src/logreader.h>

#include <string.h>

int main(int argc, char *argv[]) {
	struct strid_t *si;
	struct command_t *cmd;
	struct sqlextract_t *env;
	logfilter_error err;

	parse_options(argc, argv);

	si = strid_create();
	env = sqlextract_create(si);

	sqlextract_add_table(env, strid_get(si, "stdin"), &table_logreader, stdin);

	cmd = sqlextract_parse(env, options.filter);

	if (options.verbose) {
		printf("Using filter: %s\n", options.filter);
	}

	if (cmd) {
		command_execute(cmd, NULL, options.output_formatter);
		command_destroy(cmd);
	} else {
		err = sqlextract_last_error(env);
		printf("Got an error: %d (%s)\n", err, logfilter_strerror(err));
	}

	sqlextract_destroy(env);
	strid_destroy(si);

	deinit_options();

	return 0;
}
